subroutine DFT(N, S, Error, Dir)
!    (CooleyTukey FFT)
    integer, intent(in):: N
    complex, intent(inout):: S(0:N-1)
    integer, intent(out):: Error
    integer, intent(in), optional:: Dir
    integer, allocatable:: coef(:)
    complex, allocatable:: W(:)
    real, parameter:: dvaPi=8.0*atan(1.0)
    integer k, kk, m, p, pos, sig, N1, N2
    integer step, group, group_max, ind, bound, add, pow
    complex SS
!begin
    if(N<2) then
        Error=1; return
    endif
    p=1; k=2
    do while(k<N)
        k=k*2; p=p+1
    enddo
    if(k.ne.N) then
        Error=2; return
    endif
    sig=-1
    if(present(Dir)) sig=-sign(1, Dir)       
    N1=N-1; N2=N/2-1
    ! - 
    allocate(coef(p))
    coef(p)=1
    do k=p-1, 1, -1
        coef(k)=coef(k+1)*2
    enddo
    do k=1, N1-1
        kk=0
        do m=1, p
            if(btest(k, m-1)) then
                kk=kk+coef(m)
            endif
        enddo
        if (k<kk) then
            SS=S(k); S(k)=S(kk); S(kk)=SS
        endif
    enddo
    deallocate(coef)
    ! 
    allocate(W(0:N2))
    W(0)=cmplx(1.0, 0.0)
    do k=1, N2
        W(k)=cmplx(cos(dvaPi*k/N), sig*sin(dvaPi*k/N))
    enddo
    do step=0, p-1
        group_max=2**(p-step-1); add=2**step
        do group=0, group_max-1
            bound=group*2**(step+1); pow=0
            do ind=bound, bound+add-1
                SS=W(pow)*S(ind+add); S(ind+add)=S(ind)-SS; S(ind)=S(ind)+SS
                pow=pow+group_max
            enddo
        enddo
    enddo
    if(sig>0) then
        do k=0, n1; S(k)=S(k)/N; enddo    
    endif
    deallocate(W)
    Error=0; return
end subroutine DFT